//========================================================================
// Written by Dr. YIP Chi Lap [Beta]
//   for Workshop on "Computer-aided visibility measurement using digital cameras",
//   Visibility Measurement Method Design Competition,
//   Faculty of Engineering, The University of Hong Kong, 2012.
//========================================================================
/*
  This example illustrates the creation and use of multiple windows.
*/
//========================================================================

// The new window created is named s and is of type CustomApplet,
//   which is defined near the end of this program.
CustomApplet s;


/*
  These functions are for the first window.
*/
void setup() {
  println("first window");
  size(400, 300);
  PFrame f = new PFrame();
}

// Called periodically to redraw the screen
void draw() {
  // Normal stuff for first window
  background(255,192,192);       // First window has pink background
  stroke(255);
  fill(192);
  ellipseMode(CENTER);
  ellipse(200,150,100,60);

  /*
  // You can access the second window from the draw() of main window,
  //   but this is not recommended and is commented out here.
  s.background(192, 192, 255);   // Second window has light blue background
  s.fill(100);
  s.stroke(255);
  s.rect(10,20,200,50);
  s.redraw();
  */
}


//  Note that the rectangle is only draw when the mouse is *moved*
void mouseMoved() {
  stroke(255);
  fill(192,255,192);
  rect(mouseX-20,mouseY-20,20,20);
}

//========================================================================
/*
  Code to support the second window.
  Note that functions like setup(), draw(), mouseMoved() etc for the second window
    should be placed inside the CustomApplet definition.
*/
public class CustomApplet extends PApplet {
  public void setup() {
    // setup() of the second window
    println("second window");
  }

  // draw() of the second window
  public void draw() {
    background(192, 192, 255);   // Second window has light blue background

    // The square
    noFill();
    stroke(0);
    rect(100,150,100,100);
  }

  //  Note that the rectangle is only draw when the mouse is *moved*
  void mouseMoved() {
    stroke(255);
    fill(255,192,192);
    rect(mouseX-20,mouseY-20,20,20);
  }
}

//========================================================================
/*
  This class should be mostly unchanged except for the custimization of the window size
*/
public class PFrame extends Frame {
  public PFrame() {
    // Size of a new window is set here, 600x300 here
    setBounds(0,0,600,300);

    // These lines are needed to show the second window, leave them as-is.
    s = new CustomApplet();
    add(s);
    s.init();
    show();
  }
}

//========================================================================
